Properties Methods Events Direct Link

# Class Date

Package: | Global
Defined In: | Date.js
Class: | Date
Extends: | Object

The date parsing and formatting syntax contains a subset of PHP's date() function, and the formats that are supported will provide results equivalent to their PHP versions. The following is a list of all currently supported formats:

    Format  Description                                                               Example returned values
    ------  -----------------------------------------------------------------------   -----------------------
      d     Day of the month, 2 digits with leading zeros                             01 to 31
      D     A short textual representation of the day of the week                     Mon to Sun
      j     Day of the month without leading zeros                                    1 to 31
      l     A full textual representation of the day of the week                      Sunday to Saturday
      N     ISO-8601 numeric representation of the day of the week                    1 (for Monday) through 7 (for Sunday)
      S     English ordinal suffix for the day of the month, 2 characters             st, nd, rd or th. Works well with j
      w     Numeric representation of the day of the week                             0 (for Sunday) to 6 (for Saturday)
      z     The day of the year (starting from 0)                                     0 to 364 (365 in leap years)
      W     ISO-8601 week number of year, weeks starting on Monday                    01 to 53
      F     A full textual representation of a month, such as January or March        January to December
      m     Numeric representation of a month, with leading zeros                     01 to 12
      M     A short textual representation of a month                                 Jan to Dec
      n     Numeric representation of a month, without leading zeros                  1 to 12
      t     Number of days in the given month                                         28 to 31
      L     Whether it's a leap year                                                  1 if it is a leap year, 0 otherwise.
      o     ISO-8601 year number (identical to (Y), but if the ISO week number (W)    Examples: 1998 or 2004
            belongs to the previous or next year, that year is used instead)
      Y     A full numeric representation of a year, 4 digits                         Examples: 1999 or 2003
      y     A two digit representation of a year                                      Examples: 99 or 03
      a     Lowercase Ante meridiem and Post meridiem                                 am or pm
      A     Uppercase Ante meridiem and Post meridiem                                 AM or PM
      g     12-hour format of an hour without leading zeros                           1 to 12
      G     24-hour format of an hour without leading zeros                           0 to 23
      h     12-hour format of an hour with leading zeros                              01 to 12
      H     24-hour format of an hour with leading zeros                              00 to 23
      i     Minutes, with leading zeros                                               00 to 59
      s     Seconds, with leading zeros                                               00 to 59
      u     Decimal fraction of a second                                              Examples:
            (minimum 1 digit, arbitrary number of digits allowed)                     001 (i.e. 0.001s) or
                                                                                      100 (i.e. 0.100s) or
                                                                                      999 (i.e. 0.999s) or
                                                                                      999876543210 (i.e. 0.999876543210s)
      O     Difference to Greenwich time (GMT) in hours and minutes                   Example: +1030
      P     Difference to Greenwich time (GMT) with colon between hours and minutes   Example: -08:00
      T     Timezone abbreviation of the machine running the code                     Examples: EST, MDT, PDT ...
      Z     Timezone offset in seconds (negative if west of UTC, positive if east)    -43200 to 50400
      c     ISO 8601 date
            Notes:                                                                    Examples:
            1) If unspecified, the month / day defaults to the current month / day,   1991 or
               the time defaults to midnight, while the timezone defaults to the      1992-10 or
               browser's timezone. If a time is specified, it must include both hours 1993-09-20 or
               and minutes. The "T" delimiter, seconds, milliseconds and timezone     1994-08-19T16:20+01:00 or
               are optional.                                                          1995-07-18T17:21:28-02:00 or
            2) The decimal fraction of a second, if specified, must contain at        1996-06-17T18:22:29.98765+03:00 or
               least 1 digit (there is no limit to the maximum number                 1997-05-16T19:23:30,12345-0400 or
               of digits allowed), and may be delimited by either a '.' or a ','      1998-04-15T20:24:31.2468Z or
            Refer to the examples on the right for the various levels of              1999-03-14T20:24:32Z or
            date-time granularity which are supported, or see                         2000-02-13T21:25:33
            http://www.w3.org/TR/NOTE-datetime for more info.                         2001-01-12 22:26:34
      U     Seconds since the Unix Epoch (January 1 1970 00:00:00 GMT)                1193432466 or -2138434463
      M$    Microsoft AJAX serialized dates                                           \/Date(1238606590509)\/ (i.e. UTC milliseconds since epoch) or
                                                                                      \/Date(1238606590509+0800)\/

Example usage (note that you must escape format specifiers with '\\' to render them as character literals):

    // Sample date:
    // 'Wed Jan 10 2007 15:05:01 GMT-0600 (Central Standard Time)'

    var dt = new Date('1/10/2007 03:05:01 PM GMT-0600');
    document.write(dt.format('Y-m-d'));                           // 2007-01-10
    document.write(dt.format('F j, Y, g:i a'));                   // January 10, 2007, 3:05 pm
    document.write(dt.format('l, \\t\\he jS \\of F Y h:i:s A'));  // Wednesday, the 10th of January 2007 03:05:01 PM

Here are some standard date/time patterns that you might find helpful. They are not part of the source of Date.js, but to use them you can simply copy this block of code into any script that is included after Date.js and they will also become globally available on the Date object. Feel free to add or remove patterns as needed in your code.

    Date.patterns = {
        ISO8601Long:"Y-m-d H:i:s",
        ISO8601Short:"Y-m-d",
        ShortDate: "n/j/Y",
        LongDate: "l, F d, Y",
        FullDateTime: "l, F d, Y g:i:s A",
        MonthDay: "F d",
        ShortTime: "g:i A",
        LongTime: "g:i:s A",
        SortableDateTime: "Y-m-d\\TH:i:s",
        UniversalSortableDateTime: "Y-m-d H:i:sO",
        YearMonth: "F, Y"
    };

Example usage:

    var dt = new Date();
    document.write(dt.format(Date.patterns.ShortDate));

Developer-written, custom formats may be used by supplying both a formatting and a parsing function which perform to specialized requirements. The functions are stored in parseFunctions and formatFunctions.

## Public Properties

Property | Defined By
--- | ---
| DAY : String Date interval constant | Date
| HOUR : String Date interval constant | Date
| MILLI : String Date interval constant | Date
| MINUTE : String Date interval constant | Date
| MONTH : String Date interval constant | Date
| SECOND : String Date interval constant | Date
| YEAR : String Date interval constant | Date

dayNames : Array
An array of textual day names. Override these values for international dates. Example: Date.dayNames = [ 'SundayI...
An array of textual day names. Override these values for international dates. Example:

    Date.dayNames = [
        'SundayInYourLang',
        'MondayInYourLang',
        ...
    ];

Date

defaults : Object
An object hash containing default date values used during date parsing. The following properties are available:<div c...

An object hash containing default date values used during date parsing.

The following properties are available:

- `y` : Number
  The default year value. (defaults to undefined)
- `m` : Number
  The default 1-based month value. (defaults to undefined)
- `d` : Number
  The default day value. (defaults to undefined)
- `h` : Number
  The default hour value. (defaults to undefined)
- `i` : Number
  The default minute value. (defaults to undefined)
- `s` : Number
  The default second value. (defaults to undefined)
- `ms` : Number
  The default millisecond value. (defaults to undefined)

Override these properties to customize the default date values used by the parseDate method.

Note: In countries which experience Daylight Saving Time (i.e. DST), the `h`, `i`, `s` and `ms` properties may coincide with the exact time in which DST takes effect. It is the responsiblity of the developer to account for this.

Example Usage:

    // set default day value to the first day of the month
    Date.defaults.d = 1;

    // parse a February date string containing only year and month values.
    // setting the default day value to 1 prevents weird date rollover issues
    // when attempting to parse the following date string on, for example, March 31st 2009.
    Date.parseDate('2009-02', 'Y-m'); // returns a Date object representing February 1st 2009

Date

formatCodes : Object
The base format-code to formatting-function hashmap used by the format method. Formatting functions are strings (or f...
The base format-code to formatting-function hashmap used by the format method. Formatting functions are strings (or functions which return strings) which will return the appropriate value when evaluated in the context of the Date object from which the format method is called. Add to / override these mappings for custom date formatting. Note: Date.format() treats characters as literals if an appropriate mapping cannot be found. Example:

    Date.formatCodes.x = "String.leftPad(this.getDate(), 2, '0')";
    (new Date()).format("X"); // returns the current day of the month

Date

formatFunctions : Object
An object hash in which each property is a date formatting function. The property name is the format string which cor...

An object hash in which each property is a date formatting function. The property name is the format string which corresponds to the produced formatted date string.

This object is automatically populated with date formatting functions as date formats are requested for Ext standard formatting strings.

Custom formatting functions may be inserted into this object, keyed by a name which from then on may be used as a format string to format. Example:

    Date.formatFunctions['x-date-format'] = myDateFormatter;

A formatting function should return a string representation of the passed Date object, and is passed the following parameters:

- `date` : Date
  The Date to format.

To enable date strings to also be parsed according to that format, a corresponding parsing function must be placed into the parseFunctions property.

Date

monthNames : Array
An array of textual month names. Override these values for international dates. Example: Date.monthNames = [ 'Jan...
An array of textual month names. Override these values for international dates. Example:

    Date.monthNames = [
        'JanInYourLang',
        'FebInYourLang',
        ...
    ];

Date

monthNumbers : Object
An object hash of zero-based javascript month numbers (with short month names as keys. note: keys are case-sensitive)...
An object hash of zero-based javascript month numbers (with short month names as keys. note: keys are case-sensitive). Override these values for international dates. Example:

    Date.monthNumbers = {
        'ShortJanNameInYourLang':0,
        'ShortFebNameInYourLang':1,
        ...
    };

Date

parseFunctions : Object
An object hash in which each property is a date parsing function. The property name is the format string which that f...

An object hash in which each property is a date parsing function. The property name is the format string which that function parses.

This object is automatically populated with date parsing functions as date formats are requested for Ext standard formatting strings.

Custom parsing functions may be inserted into this object, keyed by a name which from then on may be used as a format string to parseDate.

Example:

    Date.parseFunctions['x-date-format'] = myDateParser;

A parsing function should return a Date object, and is passed the following parameters:

- `date` : String
  The date string to parse.
- `strict` : Boolean
  True to validate date strings while parsing (i.e. prevent javascript Date "rollover") (The default must be false). Invalid date strings should return null when parsed.

To enable Dates to also be formatted according to that format, a corresponding formatting function must be placed into the formatFunctions property.

Date

| useStrict : Boolean Global flag which determines if strict date parsing should be used. Strict date parsing will not roll-over invalid da... Global flag which determines if strict date parsing should be used. Strict date parsing will not roll-over invalid dates, which is the default behaviour of javascript Date objects. (see parseDate for more information) Defaults to `false`. | Date

## Public Methods

Method | Defined By
--- | ---

add( `String interval`, `Number value` ) : Date
Provides a convenient method for performing basic date arithmetic. This method does not modify the Date instance bein...
Provides a convenient method for performing basic date arithmetic. This method does not modify the Date instance being called - it creates and returns a new Date instance containing the resulting date value. Examples:

    // Basic usage:
    var dt = new Date('10/29/2006').add(Date.DAY, 5);
    document.write(dt); //returns 'Fri Nov 03 2006 00:00:00'

    // Negative values will be subtracted:
    var dt2 = new Date('10/1/2006').add(Date.DAY, -5);
    document.write(dt2); //returns 'Tue Sep 26 2006 00:00:00'

    // You can even chain several calls together in one line:
    var dt3 = new Date('10/1/2006').add(Date.DAY, 5).add(Date.HOUR, 8).add(Date.MINUTE, -30);
    document.write(dt3); //returns 'Fri Oct 06 2006 07:30:00'

Parameters:

- `interval` : String
  A valid date interval enum value.
- `value` : Number
  The amount to add to the current date.

Returns:

- `Date`
  The new Date instance.

Date

between( `Date start`, `Date end` ) : Boolean
Checks if this date falls on or between the given start and end dates.
Checks if this date falls on or between the given start and end dates.
Parameters:

- `start` : Date
  Start date
- `end` : Date
  End date

Returns:

- `Boolean`
  true if this date falls on or between the given start and end dates.

Date

clearTime( `Boolean clone` ) : Date
Attempts to clear all time information from this Date by setting the time to midnight of the same day, automatically ...
Attempts to clear all time information from this Date by setting the time to midnight of the same day, automatically adjusting for Daylight Saving Time (DST) where applicable. (note: DST timezone information for the browser's host operating system is assumed to be up-to-date)
Parameters:

- `clone` : Boolean
  true to create a clone of this date, clear the time and return it (defaults to false).

Returns:

- `Date`
  this or the clone.

Date

clone() : Date
Creates and returns a new Date instance with the exact same date value as the called instance. Dates are copied and p...
Creates and returns a new Date instance with the exact same date value as the called instance. Dates are copied and passed by reference, so if a copied date variable is modified later, the original variable will also be changed. When the intention is to create a new variable that will not modify the original instance, you should create a clone. Example of correctly cloning a date:

    //wrong way:
    var orig = new Date('10/1/2006');
    var copy = orig;
    copy.setDate(5);
    document.write(orig);  //returns 'Thu Oct 05 2006'!

    //correct way:
    var orig = new Date('10/1/2006');
    var copy = orig.clone();
    copy.setDate(5);
    document.write(orig);  //returns 'Thu Oct 01 2006'

Parameters:

- None.

Returns:

- `Date`
  The new Date instance.

Date

format( `String format` ) : String
Formats a date given the supplied format string.
Formats a date given the supplied format string.
Parameters:

- `format` : String
  The format string.

Returns:

- `String`
  The formatted date.

Date

getDayOfYear() : Number
Get the numeric day number of the year, adjusted for leap year.
Get the numeric day number of the year, adjusted for leap year.
Parameters:

- None.

Returns:

- `Number`
  0 to 364 (365 in leap years).

Date

getDaysInMonth() : Number
Get the number of days in the current month, adjusted for leap year.
Get the number of days in the current month, adjusted for leap year.
Parameters:

- None.

Returns:

- `Number`
  The number of days in the month.

Date

getElapsed( [`Date date`] ) : Number
Returns the number of milliseconds between this date and date
Returns the number of milliseconds between this date and date
Parameters:

- `date` : Date
  (optional) Defaults to now

Returns:

- `Number`
  The diff in milliseconds

Date

getFirstDateOfMonth() : Date
Get the date of the first day of the month in which this date resides.
Get the date of the first day of the month in which this date resides.
Parameters:

- None.

Returns:

- `Date`

Date

getFirstDayOfMonth() : Number
Get the first day of the current month, adjusted for leap year. The returned value is the numeric day index within t...
Get the first day of the current month, adjusted for leap year. The returned value is the numeric day index within the week (0-6) which can be used in conjunction with the monthNames array to retrieve the textual day name. Example:

    var dt = new Date('1/10/2007');
    document.write(Date.dayNames[dt.getFirstDayOfMonth()]); //output: 'Monday'

Parameters:

- None.

Returns:

- `Number`
  The day number (0-6).

Date

getGMTOffset( [`Boolean colon`] ) : String
Get the offset from GMT of the current date (equivalent to the format specifier 'O').
Get the offset from GMT of the current date (equivalent to the format specifier 'O').
Parameters:

- `colon` : Boolean
  (optional) true to separate the hours and minutes with a colon (defaults to false).

Returns:

- `String`
  The 4-character offset string prefixed with + or - (e.g. '-0600').

Date

getLastDateOfMonth() : Date
Get the date of the last day of the month in which this date resides.
Get the date of the last day of the month in which this date resides.
Parameters:

- None.

Returns:

- `Date`

Date

getLastDayOfMonth() : Number
Get the last day of the current month, adjusted for leap year. The returned value is the numeric day index within th...
Get the last day of the current month, adjusted for leap year. The returned value is the numeric day index within the week (0-6) which can be used in conjunction with the monthNames array to retrieve the textual day name. Example:

    var dt = new Date('1/10/2007');
    document.write(Date.dayNames[dt.getLastDayOfMonth()]); //output: 'Wednesday'

Parameters:

- None.

Returns:

- `Number`
  The day number (0-6).

Date

getMonthNumber( `String name` ) : Number
<static> Get the zero-based javascript month number for the given short/full month name. Override this function for internatio...
<static> Get the zero-based javascript month number for the given short/full month name. Override this function for international dates.
Parameters:

- `name` : String
  The short/full month name.

Returns:

- `Number`
  The zero-based javascript month number.

Date

getShortDayName( `Number day` ) : String
<static> Get the short day name for the given day number. Override this function for international dates.
<static> Get the short day name for the given day number. Override this function for international dates.
Parameters:

- `day` : Number
  A zero-based javascript day number.

Returns:

- `String`
  The short day name.

Date

getShortMonthName( `Number month` ) : String
<static> Get the short month name for the given month number. Override this function for international dates.
<static> Get the short month name for the given month number. Override this function for international dates.
Parameters:

- `month` : Number
  A zero-based javascript month number.

Returns:

- `String`
  The short month name.

Date

getSuffix() : String
Get the English ordinal suffix of the current day (equivalent to the format specifier 'S').
Get the English ordinal suffix of the current day (equivalent to the format specifier 'S').
Parameters:

- None.

Returns:

- `String`
  'st, 'nd', 'rd' or 'th'.

Date

getTimezone() : String
Get the timezone abbreviation of the current date (equivalent to the format specifier 'T'). Note: The date string ret...
Get the timezone abbreviation of the current date (equivalent to the format specifier 'T'). Note: The date string returned by the javascript Date object's toString() method varies between browsers (e.g. FF vs IE) and system region settings (e.g. IE in Asia vs IE in America). For a given date string e.g. "Thu Oct 25 2007 22:55:35 GMT+0800 (Malay Peninsula Standard Time)", getTimezone() first tries to get the timezone abbreviation from between a pair of parentheses (which may or may not be present), failing which it proceeds to get the timezone abbreviation from the GMT offset portion of the date string.
Parameters:

- None.

Returns:

- `String`
  The abbreviated timezone name (e.g. 'CST', 'PDT', 'EDT', 'MPST' ...).

Date

getWeekOfYear() : Number
Get the numeric ISO-8601 week number of the year. (equivalent to the format specifier 'W', but without a leading zero...
Get the numeric ISO-8601 week number of the year. (equivalent to the format specifier 'W', but without a leading zero).
Parameters:

- None.

Returns:

- `Number`
  1 to 53

Date

isDST() : Boolean
Checks if the current date is affected by Daylight Saving Time (DST).
Checks if the current date is affected by Daylight Saving Time (DST).
Parameters:

- None.

Returns:

- `Boolean`
  True if the current date is affected by DST.

Date

isLeapYear() : Boolean
Checks if the current date falls within a leap year.
Checks if the current date falls within a leap year.
Parameters:

- None.

Returns:

- `Boolean`
  True if the current date falls within a leap year, false otherwise.

Date

isValid( `Number year`, `Number month`, `Number day`, [`Number hour`], [`Number minute`], [`Number second`], [`Number millisecond`] ) : Boolean
<static> Checks if the passed Date parameters will cause a javascript Date "rollover".
<static> Checks if the passed Date parameters will cause a javascript Date "rollover".
Parameters:

- `year` : Number
  4-digit year
- `month` : Number
  1-based month-of-year
- `day` : Number
  Day of month
- `hour` : Number
  (optional) Hour
- `minute` : Number
  (optional) Minute
- `second` : Number
  (optional) Second
- `millisecond` : Number
  (optional) Millisecond

Returns:

- `Boolean`
  true if the passed parameters do not cause a Date "rollover", false otherwise.

Date

parseDate( `String input`, `String format`, [`Boolean strict`] ) : Date
<static> Parses the passed string using the specified date format. Note that this function expects normal calendar dates, mean...
<static> Parses the passed string using the specified date format. Note that this function expects normal calendar dates, meaning that months are 1-based (i.e. 1 = January). The defaults hash will be used for any date value (i.e. year, month, day, hour, minute, second or millisecond) which cannot be found in the passed string. If a corresponding default date value has not been specified in the defaults hash, the current date's year, month, day or DST-adjusted zero-hour time value will be used instead. Keep in mind that the input date string must precisely match the specified format string in order for the parse operation to be successful (failed parse operations return a null value).

Example:

    //dt = Fri May 25 2007 (current date)
    var dt = new Date();

    //dt = Thu May 25 2006 (today's month/day in 2006)
    dt = Date.parseDate("2006", "Y");

    //dt = Sun Jan 15 2006 (all date parts specified)
    dt = Date.parseDate("2006-01-15", "Y-m-d");

    //dt = Sun Jan 15 2006 15:20:01
    dt = Date.parseDate("2006-01-15 3:20:01 PM", "Y-m-d g:i:s A");

    // attempt to parse Sun Feb 29 2006 03:20:01 in strict mode
    dt = Date.parseDate("2006-02-29 03:20:01", "Y-m-d H:i:s", true); // returns null

Parameters:

- `input` : String
  The raw date string.
- `format` : String
  The expected date string format.
- `strict` : Boolean
  (optional) True to validate date strings while parsing (i.e. prevents javascript Date "rollover") (defaults to false). Invalid date strings will return null when parsed.

Returns:

- `Date`
  The parsed Date.

Date

## Public Events

This class has no public events.